
class Board {
  protected val a = Array.ofDim[Int](4, 4)

  private def displayRow(s: StringBuilder, row: Int, 
			 form: String, term: String) {
    for (col <- 0 until 4) {
      if (form == null) {
	val m = a(row)(col)
	if (m != 0)
	  s ++= "|%-4s".format("%3d".format(m))
	else
	  s ++= "|    "
      } else
	s ++= form
    }
    s ++= term
    s += '\n'
  }

  override def toString: String = {
    val s = new StringBuilder
    for (row <- 0 until 4) {
      displayRow(s, row, "o----", "o")
      displayRow(s, row, "|    ", "|")
      displayRow(s, row, null, "|")
      displayRow(s, row, "|    ", "|")
    }
    displayRow(s, 3, "o----", "o")
    s.toString
  }

  def insertRandom() {
    var free = for { 
      row <- 0 until 4
      col <- 0 until 4
      if a(row)(col) == 0
    } yield (row, col)
    val idx = (math.random * free.size).toInt
    val (row, col) = free(idx)
    a(row)(col) = if (math.random < 0.9) 2 else 4
  }

  // push tiles to the left,
  // return number of points gained
  def pushLeft(): Int = ???

  // push tiles to the right
  // return number of points gained
  def pushRight(): Int = ???

  // push tiles upwards,
  // return number of points gained
  def pushUp(): Int = ???

  // push tiles downwards,
  // return number of points gained
  def pushDown(): Int = ???

}

